package keystrokesmod.script;

import java.awt.Color;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.security.MessageDigest;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Map.Entry;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.atomic.AtomicLong;
import java.util.regex.Matcher;
import javax.tools.JavaCompiler;
import javax.tools.ToolProvider;
import keystrokesmod.Raven;
import keystrokesmod.clickgui.ClickGui;
import keystrokesmod.clickgui.components.impl.CategoryComponent;
import keystrokesmod.module.Module;
import keystrokesmod.module.Module.category;
import keystrokesmod.script.Script;
import keystrokesmod.script.ScriptDefaults;
import keystrokesmod.script.ScriptEvents;
import keystrokesmod.utility.NetworkUtils;
import keystrokesmod.utility.Utils;
import net.minecraft.client.Minecraft;
import net.minecraftforge.common.MinecraftForge;

public class ScriptManager {

   private Minecraft mc = Minecraft.func_71410_x();
   public LinkedHashMap scripts = new LinkedHashMap();
   public JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
   public boolean deleteTempFiles = true;
   public File directory;
   public List imports = Arrays.asList(new String[]{Color.class.getName(), Collections.class.getName(), List.class.getName(), ArrayList.class.getName(), Arrays.class.getName(), Map.class.getName(), HashMap.class.getName(), HashSet.class.getName(), ConcurrentHashMap.class.getName(), LinkedHashMap.class.getName(), Iterator.class.getName(), Comparator.class.getName(), AtomicInteger.class.getName(), AtomicLong.class.getName(), AtomicBoolean.class.getName(), Random.class.getName(), Matcher.class.getName()});
   public String COMPILED_DIR = System.getProperty("java.io.tmpdir") + "cmF2ZW5fc2NyaXB0cw";
   public String b = ((String[])ScriptManager.class.getProtectionDomain().getCodeSource().getLocation().getPath().split("\\.jar!"))[0].substring(5) + ".jar";
   private Map loadedHashes = new HashMap();


   public ScriptManager() {
      this.directory = new File(this.mc.field_71412_D + File.separator + "keystrokes", "scripts");
   }

   public void onEnable(Script dv) {
      if(dv.event == null) {
         dv.event = new ScriptEvents(this.getModule(dv));
         MinecraftForge.EVENT_BUS.register(dv.event);
      }

      dv.invoke("onEnable", new Object[0]);
   }

   public Module getModule(Script dv) {
      Iterator var2 = this.scripts.entrySet().iterator();

      Entry entry;
      do {
         if(!var2.hasNext()) {
            return null;
         }

         entry = (Entry)var2.next();
      } while(!((Script)entry.getKey()).equals(dv));

      return (Module)entry.getValue();
   }

   public void loadScripts() {
      Iterator scriptDirectory = this.scripts.values().iterator();

      while(scriptDirectory.hasNext()) {
         Module scriptFiles = (Module)scriptDirectory.next();
         scriptFiles.disable();
      }

      File[] categoryComponent;
      int hash;
      int cachedHash;
      File scriptFile;
      File var10;
      File[] var11;
      if(this.deleteTempFiles) {
         this.deleteTempFiles = false;
         var10 = new File(this.COMPILED_DIR);
         if(var10.exists() && var10.isDirectory()) {
            var11 = var10.listFiles();
            if(var11 != null) {
               categoryComponent = var11;
               hash = var11.length;

               for(cachedHash = 0; cachedHash < hash; ++cachedHash) {
                  scriptFile = categoryComponent[cachedHash];
                  if(!scriptFile.delete()) {
                     System.err.println("Failed to delete temp file: " + scriptFile.getAbsolutePath());
                  }
               }
            }
         }
      } else if(!this.scripts.isEmpty()) {
         scriptDirectory = this.scripts.entrySet().iterator();

         while(scriptDirectory.hasNext()) {
            Entry var12 = (Entry)scriptDirectory.next();
            String var13 = ((Script)var12.getKey()).file.getName();
            String var16 = this.calculateHash(((Script)var12.getKey()).file);
            String var18 = (String)this.loadedHashes.get(var13);
            if(var18 == null || !var18.equals(var16) || ((Script)var12.getKey()).error) {
               ((Script)var12.getKey()).delete();
               scriptDirectory.remove();
               this.loadedHashes.remove(var13);
            }
         }
      } else {
         this.loadedHashes.clear();
      }

      var10 = this.directory;
      if(var10.exists() && var10.isDirectory()) {
         var11 = var10.listFiles();
         if(var11 != null) {
            categoryComponent = var11;
            hash = var11.length;

            for(cachedHash = 0; cachedHash < hash; ++cachedHash) {
               scriptFile = categoryComponent[cachedHash];
               if(scriptFile.isFile() && scriptFile.getName().endsWith(".java")) {
                  String fileName = scriptFile.getName();
                  String hash1 = this.calculateHash(scriptFile);
                  String cachedHash1 = (String)this.loadedHashes.get(fileName);
                  if(cachedHash1 == null || !cachedHash1.equals(hash1)) {
                     this.parseFile(scriptFile);
                     this.loadedHashes.put(scriptFile.getName(), hash1);
                  }
               }
            }
         }
      } else if(var10.mkdirs()) {
         System.out.println("Created script directory: " + var10.getAbsolutePath());
      } else {
         System.err.println("Failed to create script directory: " + var10.getAbsolutePath());
      }

      Iterator var14 = this.scripts.values().iterator();

      while(var14.hasNext()) {
         Module var15 = (Module)var14.next();
         var15.disable();
      }

      ClickGui var10000 = Raven.clickGui;
      var14 = ClickGui.categories.iterator();

      while(var14.hasNext()) {
         CategoryComponent var17 = (CategoryComponent)var14.next();
         if(var17.category == category.scripts) {
            var17.reloadModules(false);
         }
      }

      ScriptDefaults.reloadModules();
   }

   private boolean parseFile(File file) {
      if(!file.getName().startsWith("_") && file.getName().endsWith(".java")) {
         String scriptName = file.getName().replace(".java", "");
         if(scriptName.isEmpty()) {
            return false;
         } else {
            StringBuilder scriptContents = new StringBuilder();

            String module;
            try {
               BufferedReader topLevelLines = new BufferedReader(new FileReader(file));
               Throwable script = null;

               try {
                  while((module = topLevelLines.readLine()) != null) {
                     scriptContents.append(module).append("\n");
                  }
               } catch (Throwable var16) {
                  script = var16;
                  throw var16;
               } finally {
                  if(topLevelLines != null) {
                     if(script != null) {
                        try {
                           topLevelLines.close();
                        } catch (Throwable var15) {
                           script.addSuppressed(var15);
                        }
                     } else {
                        topLevelLines.close();
                     }
                  }

               }
            } catch (Exception var18) {
               var18.printStackTrace();
            }

            if(scriptContents.length() == 0) {
               return false;
            } else {
               List topLevelLines1 = Utils.getTopLevelLines(scriptContents.toString());
               Iterator script1 = topLevelLines1.iterator();

               while(script1.hasNext()) {
                  module = (String)script1.next();
                  if(module.startsWith("load - \"") && module.endsWith("\"")) {
                     String url = module.substring("load - \"".length(), module.length() - 1);
                     String externalContents = NetworkUtils.getTextFromURL(url, true, true);
                     if(externalContents.isEmpty()) {
                        break;
                     }

                     int loadIndex = scriptContents.indexOf(module);
                     if(loadIndex != -1) {
                        scriptContents.replace(loadIndex, loadIndex + module.length(), externalContents);
                     }
                  }
               }

               Script script2 = new Script(scriptName);
               script2.file = file;
               script2.setCode(scriptContents.toString());
               script2.run();
               Module module1 = new Module(script2);
               Raven.scriptManager.scripts.put(script2, module1);
               ScriptDefaults.reloadModules();
               Raven.scriptManager.invoke("onLoad", module1, new Object[0]);
               return !script2.error;
            }
         }
      } else {
         return false;
      }
   }

   public void onDisable(Script script) {
      if(script.event != null) {
         MinecraftForge.EVENT_BUS.unregister(script.event);
         script.event = null;
      }

      script.invoke("onDisable", new Object[0]);
   }

   public void invoke(String methodName, Module module, Object ... args) {
      Iterator var4 = this.scripts.entrySet().iterator();

      while(var4.hasNext()) {
         Entry entry = (Entry)var4.next();
         if((((Module)entry.getValue()).canBeEnabled() && ((Module)entry.getValue()).isEnabled() || methodName.equals("onLoad")) && ((Module)entry.getValue()).equals(module)) {
            ((Script)entry.getKey()).invoke(methodName, args);
         }
      }

   }

   public int invokeBoolean(String methodName, Module module, Object ... args) {
      Iterator var4 = this.scripts.entrySet().iterator();

      while(var4.hasNext()) {
         Entry entry = (Entry)var4.next();
         if(((Module)entry.getValue()).canBeEnabled() && ((Module)entry.getValue()).isEnabled() && ((Module)entry.getValue()).equals(module)) {
            int c = ((Script)entry.getKey()).getBoolean(methodName, args);
            if(c != -1) {
               return c;
            }
         }
      }

      return -1;
   }

   private String calculateHash(File file) {
      try {
         MessageDigest e = MessageDigest.getInstance("SHA-256");
         byte[] fileBytes = Files.readAllBytes(Paths.get(file.getPath(), new String[0]));
         byte[] hashBytes = e.digest(fileBytes);
         StringBuilder hexString = new StringBuilder();
         byte[] var6 = hashBytes;
         int var7 = hashBytes.length;

         for(int var8 = 0; var8 < var7; ++var8) {
            byte b = var6[var8];
            hexString.append(String.format("%02x", new Object[]{Byte.valueOf(b)}));
         }

         return hexString.toString();
      } catch (Exception var10) {
         return "";
      }
   }
}
